<?php defined('SYSPATH') || die('No direct script access.');

class Controller_Office_Roles extends Controller_Environment_Office
{
    protected static function checkRole($roleID, $roles)
    {
        foreach ($roles as $role) {
            if ( $role['ID'] == $roleID )
                return true;
        }
        return false;
    }

    public function action_change() {
        $ID = $this->request->param('id');

        if( !$this->user->isAdmin() )
            throw HTTP_Exception::factory(403, "У вас нет прав менять роли.");

        if( (int)$ID == 0 )
            throw HTTP_Exception::factory(400, "Не задан ID преподавателя.");

        $role = (int) $this->request->post('role');
        $roles = Model_Roles::getRoles();

        $res = false;
        if(self::checkRole($role, $roles)) {
            $setRoleResult = Model_Roles::setRole($ID, $role);
            if($setRoleResult)
                $res = "Роль изменена";
            else
                $res = "Роль не изменена";
        } elseif($role > 0) {
            $res = "Недопустимая роль";
        }

        $user  = Model_Roles::getAccountInfo($ID, $this->user->SemesterID);

        $display = [
            'result'        => $res,
            'tID'           => $ID,
            'tName'         => $user['name'],
            'tRole'         => $user['RoleID'],
            'tRoleName'     => $user['Role'],
            'tRoleVariants' => $roles
        ];

        $this->twig->set_filename(static::OFFICE . 'roles/change')->set($display);
    }
}
